// WAIT FOR WINDOW TO LOAD:
var socket;
var devTest = false;
var fetchedBoards = ",";
var rankLeaderboard = document.getElementById("rankLeaderboard");
var rankButton = document.getElementById("rankButton");
var kdrLeaderboard = document.getElementById("kdrLeaderboard");
var kdrButton = document.getElementById("kdrButton");
var kdrLeaderboard2 = document.getElementById("kdr2Leaderboard");
var kdrButton2 = document.getElementById("kdr2Button");
var killsLeaderboard = document.getElementById("killsLeaderboard");
var killsButton = document.getElementById("killsButton");
window.onload = function () {
	$.get("/getIP", function (data) {
	    if (!socket) {
			var tmpIP = devTest ? 'localhost' : data.ip;
			socket = io.connect('http://' + tmpIP + ':' + data.port, {
				reconnection: false,
				forceNew: true,
				query: 'fetchLeaderboards=' + true
			});
			socket.on('getLeaderboards', function (response, lType, worked) {
				if (worked) {
					console.log(response);
					var tmpHTML = "";
					var leaderList = response;
					if (lType == "rank") {
			        	for (var i = 0; i < leaderList.length; ++i) {
			        		tmpHTML += "<div onclick='showUserStatPage(\"" + leaderList[i].user_name + "\")' class='leaderboardItemWrapper'>" + (i + 1) + ". <span class='clanDisplay'>" + (leaderList[i].user_clan != '' ? ("[" + leaderList[i].user_clan.toUpperCase() + "] ") : "") + "</span><span class='leaderNameDisplay'>" + leaderList[i].user_name + " RNK " + leaderList[i].user_rank + "</span></div>";
			            }
						rankLeaderboard.innerHTML = tmpHTML;	
					} else if (lType == "kills") {
			        	for (var i = 0; i < leaderList.length; ++i) {
			        		tmpHTML += "<div onclick='showUserStatPage(\"" + leaderList[i].user_name + "\")' class='leaderboardItemWrapper'>" + (i + 1) + ". <span class='clanDisplay'>" + (leaderList[i].user_clan != '' ? ("[" + leaderList[i].user_clan.toUpperCase() + "] ") : "") + "</span><span class='leaderNameDisplay'>" + leaderList[i].user_name + " " + leaderList[i].user_kills + " KILLS</span></div>";
			            }
			        	killsLeaderboard.innerHTML = tmpHTML;	
					} else {
						var tmpKD = 0;
						for (var i = 0; i < leaderList.length; ++i) {
							tmpKD = (Math.max(1, leaderList[i].user_kills) / Math.max(1, leaderList[i].user_deaths)).toFixed(2);
			        		tmpHTML += "<div onclick='showUserStatPage(\"" + leaderList[i].user_name + "\")' class='leaderboardItemWrapper'>" + (i + 1) + ". <span class='clanDisplay'>" + (leaderList[i].user_clan != '' ? ("[" + leaderList[i].user_clan.toUpperCase() + "] ") : "") + "</span><span class='leaderNameDisplay'>" + leaderList[i].user_name + " KDR " + tmpKD + " (" + leaderList[i].user_kills + "/" + leaderList[i].user_deaths + ")</span></div>";
			            }
						if (lType == "kdr") {
							kdrLeaderboard.innerHTML = tmpHTML;	
						} else if (lType == "kdr2") {
							kdrLeaderboard2.innerHTML = tmpHTML;
						}
					} 					
				} else {
					rankLeaderboard.innerHTML = "<div class='leaderMessage'><b>" + response + "</b></div>";
					kdrLeaderboard.innerHTML = "<div class='leaderMessage'><b>" + response + "</b></div>";
					kdrLeaderboard2.innerHTML = "<div class='leaderMessage'><b>" + response + "</b></div>";
				}
			});
			socket.on('connect_failed', function () {
				serverMessage.innerHTML = "Connection Failed. Try again later.";
		    });
			toggleLeaderboardDisplay('rank');
		}
	});
};

// CHANGE DISPLAY:
function toggleLeaderboardDisplay(board) {
	// HIDE ALL:
	rankLeaderboard.style.display = "none";
	rankButton.className = "changeLeaderbordButton";
	kdrLeaderboard.style.display = "none";
	kdrButton.className = "changeLeaderbordButton";
	kdrLeaderboard2.style.display = "none";
	kdrButton2.className = "changeLeaderbordButton";
	killsLeaderboard.style.display = "none";
	killsButton.className = "changeLeaderbordButton";
	
	// FETCH DATA:
	if (socket && fetchedBoards.indexOf("," + board + ",") < 0) {
		fetchedBoards += board + ",";
		socket.emit('ftchLead', board);
	}
	
	// SHOW BOARD:
	document.getElementById(board + "Leaderboard").style.display = "block";
	document.getElementById(board + "Button").className += " activeButton";
}

// CLICK ON USER:
function showUserStatPage(userName) {
	window.open('/profile.html?' + userName,'_blank');
}